#include "esh_types.h"

#ifndef ESH_MAIN_LOOP_H
#define ESH_MAIN_LOOP_H

void EShRunLoop();

void EShShowMsg();

void EShParseCommandIntoJobs(char* command);

void EShExecuteJobs(int jobs_num, EShJob* jobs_list);

void EShSetJobCommandType(EShJob* job);

void EShRunJob(EShJob* job);

int EmptyCommand(const char* command);

int InnerCommand(const char* command);

void EShProcessInnerJob(const char* command);

void EShProcessExecJob(const char* command);

#endif // ESH_MAIN_LOOP_H